/*{
	"type": "action",
	"author": "Nyhthawk Productions",
	"description": "Dynamically creates hierarchic diagrams by displaying the subordinates of the selected hierarchical graphic.",
	"label": "Display Subordinates",
	"shortLabel": "Display Subordinates"
}*/

var _ = function(){
	
	var action = new PlugIn.Action(function(selection, sender){
		// action code
		var cnvs = selection.canvas
		var sourceGraphic = selection.graphics[0]
		console.log(sourceGraphic.name)
		// get employee ID from user data
		employeeID = sourceGraphic.userData['Employee ID']
		// get JSON from canvas notes
		var orgJSON = cnvs.background.notes
		reports = getReportsForID(orgJSON,employeeID)
		if (reports != []){
			console.log('adding subordinates')
			reports.forEach(function(empID){
				empName = getOtherKeyValueForObjWithKeyValue(orgJSON,'Employee ID',empID,'Name')
				cloneConnectRename(sourceGraphic,empName,empID)
			})
			console.log('performing layout')
			document.windows[0].selection.canvas.layout()
			if (cnvs.automaticLayout === false){
				console.log('bounds of canvas content')
				var g = document.windows[0].selection.canvas.graphics
				var gr = new Group(g)
				var rect =  gr.geometry
				gr.ungroup()
				console.log('zoom and center')
				document.windows[0].selection.view.visibleRect = rect
				document.windows[0].centerVisiblePoint = rect.center
			}
			console.log('select source graphic')
			document.windows[0].selection.view.select([sourceGraphic],false)
			console.log(sourceGraphic.name)
		}
	})

	action.validate = function(selection, sender){
		// validation code
		if(selection.graphics.length === 1){return true} else {return false}
	};

	return action;
}();
_;

function getReportsForID(data,empID){
	jObj = JSON.parse(data)
	var reports = []
	for (i = 0; i < jObj.length; i++) { 
		jItem = jObj[i]
		if (jItem['Employee ID'] == empID){
			reports = jItem['Reports']
			break
		}
	}
	return reports
}

function getOtherKeyValueForObjWithKeyValue(data,pivotKey,pivotValue,targetKey){
	jObj = JSON.parse(data)
	for (i = 0; i < jObj.length; i++){ 
		jItem = jObj[i]
		if (jItem[pivotKey] == pivotValue){
			return jItem[targetKey]
		}
	}
	return null
}

function cloneConnectRename(graphic,empName,empID){
	cnvs = document.windows[0].selection.canvas
	graphic.allowsConnections = true
	geo = graphic.geometry
	offset = 72
	clone = graphic.duplicateTo(new Point(geo.minX, geo.maxY + offset),cnvs)
	line = cnvs.connect(graphic,clone)
	line.lineType = LineType.Straight
	if(graphic.strokeColor == null){
		lcolor = Color.black
	} else {
		lcolor = graphic.strokeColor
	}
	line.strokeColor = lcolor
	line.shadowColor = null
	line.strokeThickness = 4
	line.strokeType = StrokeType.Single
	line.headType = 'Arrow'
	line.tailType = 'None'
	clone.setUserData('Employee ID',empID)
	clone.setUserData('Employee Name',empName)
	clone.name = empName + ' ' + empID
	clone.text = empName + '\n' + empID
	cnvs.layout()
}